
/*
    "Skeleton template Code example" by D Henderson orbiter@aibs.org.uk (BurnTimeCalcMFD (BTC) 1.1)

    Copyright 2007 by Topper topperte301@arcor.de
    Released under the terms of the LGPL: http://www.gnu.org/licenses/lgpl.txt

    This software nad sourcecode is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#define STRICT
#define ORBITER_MODULE

//Color definitions for printing text
#define WHITE RGB(255, 255, 255)
#define GREEN RGB(0, 255, 0)
#define YELLOW RGB(255, 255, 0)
#define BLUE RGB(0, 0, 255)
#define GREY RGB(127,127,127)
//Standard includes...
#include "orbitersdk.h"
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

//This class
#define BLOCKCOUNTS 60
#define BALLS 1


#define VIRTUALPIXEL *(width / 320.0)

#include "Orbinuid.h"

//I don't know for what this is?
static struct
{
   int mode;
} g_orbinuidMFD;

orbinuidMFD *orbinuid;

//Registration of the comiled DLL from this source
DLLCLBK void opcDLLInit (HINSTANCE hDLL)
{
   static char *name = "Orbinoid";
   MFDMODESPEC spec;
   spec.name    = name;
   spec.key     = OAPI_KEY_N;
   spec.msgproc = orbinuidMFD::MsgProc;
   g_orbinuidMFD.mode = oapiRegisterMFDMode (spec);
   orbinuid = NULL;
}

//DLL- Unregister
DLLCLBK void opcDLLExit (HINSTANCE hDLL)
{
   oapiUnregisterMFDMode (g_orbinuidMFD.mode);
}

//Constructor of this class. These methot will be run everytime the MFD will build,
//even when chance to external view and back to internal view.
orbinuidMFD::orbinuidMFD (DWORD w, DWORD h, VESSEL *vessel) : MFD (w, h, vessel)
{
	
   height = (int)h;  //Pixelhight of the MFD??
   width = (int)w;
   MyBall.X_Pos = int(Cursor.left+(Cursor.width/2))VIRTUALPIXEL;
   MyBall.Y_Pos = int(Cursor.gnd-Cursor.height)VIRTUALPIXEL;
   MyBall.X_Vec = 0 VIRTUALPIXEL;
   MyBall.Y_Vec = 0 VIRTUALPIXEL;
   Cursor.width =  int (35.0 VIRTUALPIXEL);
   Cursor.height = int (10.0 VIRTUALPIXEL);
   Cursor.gnd = int (height - 10.0 VIRTUALPIXEL);
   Game.FirstZyclus = true;
   Player1.Score=0;
   Player1.Balls = BALLS;
   MyBall.free = false;
   Player1.level = 0;
   Game.NewBall = true;
   Game.Over = false;
   MyBall.Radius = int (3 VIRTUALPIXEL);  
}

orbinuidMFD::~orbinuidMFD () {}  //Destructor (not used now)

//This function will be called at any MFD-refresh.
//It can be chanced by Orbiter-launchpad (Parameters->MFD-Refreshrate)
void orbinuidMFD::Update (HDC hDC)
{
   MFD_HDC = hDC;   //This is a Object-Handel to tell witch Object in Orbiter will be used for printing out.
   SetTextColor(MFD_HDC,GREEN);   //Setting up the color...
   PrintNewLine(":@BEGIN:");   //This is the first point where we printing out text
                                        //End of refresh...
   pong(false);
   if(boolean_debugVar)
   {
   char DebugVar[255];
   sprintf(DebugVar,"%f",MyBall.Y_Vec );   
   int LenDVar = strlen(DebugVar);
   TextOut(MFD_HDC, 0,line(18),DebugVar,LenDVar);
   }


}
void orbinuidMFD::pong(bool newball)
{
   GetMousePos();
   
   PutMenueText(newball);

   //Stop here when game is over or next level has been reached

   if (Player1.level == 0 && !Game.FirstZyclus) CheckWon();
   if (Game.Over || Player1.level == 1 ) return;  

   //If this it is the first ball /round, draw and set blocks
   if (Game.FirstZyclus)
   {
      Game.NewBall = true;
      CreateBlocks();
   }
   

   DrawBlocks();
   DrawCursor();
   WatchForRelease();

   //Moves the Ball 10 times...
   DrawBall();
   for (int lauf = 0; lauf < 10; lauf++) 
   {
      MoveBall();
      CheckBlockCollision();
	  CheckEdges();
	  if (Game.NewBall || Game.Over) break;
   }
   //... But draw it only one time (for better computing because of the bad refresh rate)
   
   Game.FirstZyclus = false;
}
void orbinuidMFD::WatchForRelease()
{
   if (Game.NewBall)
   {
      //if (!first) 
	  //{
	  PrintNewLine("");
	  PrintNewLine("");
	  PrintNewLine("");
	  PrintNewLine("");
	  PrintNewLine("");
	  PrintNewLine("");
	  PrintNewLine("");
	  PrintNewLine("");
	  PrintNewLine("");
	  PrintNewLine("");

      SetTextColor(MFD_HDC,WHITE);
	  PrintNewLine("      Release ball! (Shift+R) ");
	  //}
	  //Release ball
      MyBall.X_Pos = float(Cursor.left+(Cursor.width/2));
	  MyBall.Y_Pos = float(Cursor.gnd-Cursor.height-MyBall.Radius/2);
      MyBall.X_Vec = 0;
      MyBall.Y_Vec = 0;    
   }
}
void orbinuidMFD::PutMenueText(bool newball)
{
   //Start Menue
   //Output Score
   char ScoreString[255];
   sprintf(ScoreString,"%i",Player1.Score);   
   TextOut(MFD_HDC, 0,line(0)," Score: ",7);
   int score_len = strlen(ScoreString); 
   TextOut(MFD_HDC, 90,line(0),ScoreString,score_len);
   //Output Ballstring
   char BallsString[255];
   sprintf(BallsString,"%i",Player1.Balls);   
   TextOut(MFD_HDC, width - 100,line(0),"Balls: ",7);
   //Setting Ballstring to Zero if it is -1 (= Game Over)
   int Balls_len = strlen(BallsString); 
   if (Player1.Balls != -1)
      TextOut(MFD_HDC, width - 20,line(0),BallsString,Balls_len);
   else
      TextOut(MFD_HDC, width - 20,line(0),"0",1);
   if (Player1.Balls != -1) Game.Over = false;

   //Putting out Game Over Srting when Game is Over
   if (Game.Over)
   {
      TextOut(MFD_HDC, (width/2)-70,height/2,"- Game Over! -",14);      
   }
   //Putting out String when level is clear
   if (Player1.level == 1 )
   {
      TextOut(MFD_HDC, (width/2)-70,height/2,"- Level Clear! -",16);      
   }
   if (newball)
   {
      //Setting Ballpos rel. to cursor pos and cursor is in range
	  MyBall.X_Pos = float(Cursor.left+(Cursor.width/2));
	  MyBall.Y_Pos = float(Cursor.gnd-Cursor.height);
	  //Setting Ballpos when mouse is out of range
      if (Cursor.left + Cursor.width > width)
      {
	     MyBall.X_Pos = float(width-Cursor.width/2);
      }
	  //Setting speed when Ball has been released
      MyBall.X_Vec = 0.5 VIRTUALPIXEL;
      MyBall.Y_Vec = -1.0 VIRTUALPIXEL;
	  Game.NewBall=false;
	  MyBall.free = true;
   }

}

void orbinuidMFD::GetMousePos()
{
   //Getting mousepos
   POINT pos;
   static xposAlt = 0;
   GetCursorPos(&pos);
   int MouseSens = 2;
   int DeltaXPos = (pos.x - xposAlt) / MouseSens;
   if (Cursor.left + DeltaXPos >= 0) Cursor.left = Cursor.left + DeltaXPos;
   else Cursor.left = 0;

   xposAlt = pos.x;

   //pos.x = MyBall.X_Pos-(Cursor.width/2.0);

   /* //Simple Automode
   if (pos.x>0 )
      */


}

void orbinuidMFD::DrawCursor()
{
	SetTextColor(MFD_HDC,YELLOW);
   if (Cursor.left + Cursor.width > width)
   {
	   Cursor.left = width-Cursor.width;
	   if (Game.NewBall) MyBall.X_Pos = float(Cursor.left+(Cursor.width/2));
   }
   int CursorLX = Cursor.left;
   int CursorBY = Cursor.gnd;
   int CursorRX = Cursor.left+Cursor.width;
   int CursorTY = Cursor.gnd-Cursor.height;
   
   //move to top-left
 

   HPEN pen;
   pen=SelectDefaultPen(MFD_HDC,5);
   
   int CurrWidth = Cursor.width;
   int CurrLeft = Cursor.left;
   int ROutCircle = Cursor.height;

   for(int lauf=0; lauf<Cursor.height; lauf++)
   { 
      MoveToEx (MFD_HDC, CurrLeft+(ROutCircle/2), Cursor.gnd-Cursor.height+lauf, NULL);
	  LineTo (MFD_HDC, CurrLeft+CurrWidth-(ROutCircle/2), Cursor.gnd-Cursor.height+lauf);
   }
   //Draws the roundings on the sides
   for(int CircZoom=0;CircZoom < Cursor.height; CircZoom++)
   {
      Ellipse (MFD_HDC, Cursor.left+CircZoom, 
	   				    Cursor.gnd-Cursor.height+CircZoom, 
					    Cursor.left+ROutCircle-CircZoom, 
					    Cursor.gnd-CircZoom) ;

      Ellipse (MFD_HDC, Cursor.left+Cursor.width-ROutCircle+CircZoom, 
					    Cursor.gnd-Cursor.height+CircZoom, 
					    Cursor.left+Cursor.width-CircZoom , 
					    Cursor.gnd-CircZoom) ;
   }
   //Filling the dirty black dots on the paddel


   SetPixel(MFD_HDC,Cursor.left+Cursor.height/2-1,Cursor.gnd - Cursor.height/2-2,GREY);
   SetPixel(MFD_HDC,Cursor.left+Cursor.height/2-1,Cursor.gnd - Cursor.height/2,GREY);
   SetPixel(MFD_HDC,Cursor.width+Cursor.left-Cursor.height/2,Cursor.gnd - Cursor.height/2-1,GREY);
   SetPixel(MFD_HDC,Cursor.width+Cursor.left-Cursor.height/2,Cursor.gnd - Cursor.height/2-2,GREY);
   SetPixel(MFD_HDC,Cursor.width+Cursor.left-Cursor.height/2,Cursor.gnd - Cursor.height/2,GREY);


   pen=SelectDefaultPen(MFD_HDC,1);

/*  
HPEN hPen;
hPen = CreatePen(PS_SOLID,2,RGB(23,55,77));
*/


/*


   Rectangle (MFD_HDC, 
	          CursorLX,
			  CursorTY, 
		      CursorRX,
			  CursorBY);
			  
  */

}

void orbinuidMFD::DrawBall()
{
   HPEN pen;
   pen=SelectDefaultPen(MFD_HDC,0);

   for (int lauf=0; lauf<=MyBall.Radius;lauf++)
   {
      int IntXPosBallLeft = int(MyBall.X_Pos-lauf);
      int IntXPosBallRight = int(MyBall.X_Pos+lauf);
      int IntYPosBallTop = int(MyBall.Y_Pos-lauf);
      int IntYPosBallButtom= int(MyBall.Y_Pos+lauf);
      Ellipse (MFD_HDC, IntXPosBallLeft, IntYPosBallTop, IntXPosBallRight, IntYPosBallButtom);
   }
   int Ballcolor = GREEN;

   SetPixel (MFD_HDC, MyBall.X_Pos-1, MyBall.Y_Pos-1, Ballcolor);
   SetPixel (MFD_HDC, MyBall.X_Pos-1, MyBall.Y_Pos+0, Ballcolor);
   SetPixel (MFD_HDC, MyBall.X_Pos-1, MyBall.Y_Pos+1, Ballcolor);
   SetPixel (MFD_HDC, MyBall.X_Pos-0, MyBall.Y_Pos-1, Ballcolor);
   SetPixel (MFD_HDC, MyBall.X_Pos+0, MyBall.Y_Pos+0, Ballcolor);
   SetPixel (MFD_HDC, MyBall.X_Pos+0, MyBall.Y_Pos+1, Ballcolor);
   SetPixel (MFD_HDC, MyBall.X_Pos+1, MyBall.Y_Pos-1, Ballcolor);
   SetPixel (MFD_HDC, MyBall.X_Pos+1, MyBall.Y_Pos+0, Ballcolor);
   SetPixel (MFD_HDC, MyBall.X_Pos+1, MyBall.Y_Pos+1, Ballcolor);

}
void orbinuidMFD::MoveBall()
{
   MyBall.X_Pos=MyBall.X_Pos+MyBall.X_Vec;
   MyBall.Y_Pos=MyBall.Y_Pos+MyBall.Y_Vec;
}
void orbinuidMFD::CheckEdges()
{
   //Seitliche Bande
   if (MyBall.X_Pos + MyBall.Radius >= width) 
   {
      MyBall.X_Vec=-MyBall.X_Vec;
	  //DrawBall();
   }
   if (MyBall.X_Pos - MyBall.Radius <= 0)     
   {
      MyBall.X_Vec=-MyBall.X_Vec;
	  //DrawBall();
   }
   if (MyBall.Y_Pos - MyBall.Radius <= 0) 
   {
      MyBall.Y_Vec=-MyBall.Y_Vec;
	  //DrawBall();
   }
   if (MyBall.Y_Pos + MyBall.Radius > Cursor.gnd - Cursor.height && MyBall.Y_Vec>0)
   {
	   if (Cursor.left <= MyBall.X_Pos && Cursor.left+Cursor.width >= MyBall.X_Pos )
	   {
	      //Ball has hit the Cursor
	      //MyBall.Y_Vec=-MyBall.Y_Vec;

		  //BallRel is the Relatice Hitpoint on the Paddel
		  double BallRel = MyBall.X_Pos - (Cursor.left + (Cursor.width/2.0));

		  // vGup2 is the total vector^2 of the ball
		  //double vGup2 = MyBall.X_Vec*MyBall.X_Vec + MyBall.Y_Vec*MyBall.Y_Vec;            
		  double Vx = MyBall.X_Vec;
		  double Vy = MyBall.Y_Vec;
		  double VxUp2 = Vx * Vx;
		  double VyUp2 = Vy * Vy;

		  double Vg = sqrt(VxUp2+VyUp2);
		  double Alpha = acos(Vx/Vg);
		  double DeltaAlpha = -BallRel / 20; //how strong does the vector chance?
		  double AlphaNew = Alpha + DeltaAlpha;
		  double MinAngel = 0.2;
		  boolean_debugVar = false;

		  if (AlphaNew < MinAngel )      AlphaNew = MinAngel;
		  if (AlphaNew + MinAngel > PI ) AlphaNew = PI - MinAngel;
		  
		  double VxNew = Vg * cos(AlphaNew);
		  double VyNew = -Vg * sin(AlphaNew);

		  MyBall.X_Vec = VxNew;
		  MyBall.Y_Vec = VyNew;

		  DrawBall();
	   }
	   else
	   {
		   //Ball has passed the Cursor
		   Game.NewBall = true;
		   MyBall.free = false;
		   Player1.Balls = Player1.Balls - 1;
		   if(Player1.Balls == -1) Game.Over = true;
	   }
   }

}

void orbinuidMFD::CreateBlocks()
{

   int Xspace = int (35 VIRTUALPIXEL);
   int Yspace = int (24 VIRTUALPIXEL);
   int OffsetLeft = int (2 VIRTUALPIXEL);

   int LaufXLeft = OffsetLeft;
   int LaufYTop = int (45 VIRTUALPIXEL);
   int zeile = 0;
   for(int lauf=0;lauf < BLOCKCOUNTS;lauf++)
   {
      Blocks[lauf].X_Left=LaufXLeft;
      Blocks[lauf].Y_Top =LaufYTop;
      Blocks[lauf].width = int (30 VIRTUALPIXEL);
      Blocks[lauf].height  = int(10 VIRTUALPIXEL);
	  Blocks[lauf].exist = true;
	  Blocks[lauf].lives = 1;
	  Blocks[lauf].color = 2;
	  if (lauf > BLOCKCOUNTS-10 || lauf < 9)
	  {
         Blocks[lauf].lives = 2;
		 Blocks[lauf].color = 3;
	  }

	  LaufXLeft = LaufXLeft + Xspace;
      
	  if (LaufXLeft + Xspace > width)
	  {
	     zeile++;
		 if(zeile%2 == 0) 
		    LaufXLeft = OffsetLeft;
		 else 
		    LaufXLeft = int(OffsetLeft + (Blocks[lauf].width+(Xspace-Blocks[lauf].width )) / 2.0) ;

	     LaufYTop = LaufYTop + Yspace;
	  }
   }
}

void orbinuidMFD::DrawBlocks()
{
   for(int lauf=0;lauf < BLOCKCOUNTS;lauf++)
   {
	   SelectDefaultPen(MFD_HDC, Blocks[lauf].color);
	   if (Blocks[lauf].exist)
	   {
	      /*
	      Rectangle (MFD_HDC, Blocks[lauf].X_Left,
							  Blocks[lauf].Y_Top , 
			                  Blocks[lauf].X_Left + Blocks[lauf].width ,
							  Blocks[lauf].Y_Top +  Blocks[lauf].height );   	
		  */
		   
		  for(int laufh=0; laufh<Blocks[lauf].height; laufh++)
		  { 
		     MoveToEx (MFD_HDC, Blocks[lauf].X_Left                     , Blocks[lauf].Y_Top + laufh , NULL);
			 LineTo   (MFD_HDC, Blocks[lauf].X_Left + Blocks[lauf].width, Blocks[lauf].Y_Top + laufh);
		  }

	   }
   }
}

void orbinuidMFD::CheckBlockCollision()
{
//	int BallTop = MyBall.Y_Pos - MyBall.Radius;
//	int BallCenter = MyBall.X_Pos
   for(int lauf=0;lauf < BLOCKCOUNTS;lauf++) //For each block
   {
      if (Blocks[lauf].exist)
      {
         if (MyBall.Y_Vec < 0)
         {
            //Collision from Button
			 if (MyBall.Y_Pos <= Blocks[lauf].Y_Top+Blocks[lauf].height && MyBall.Y_Pos-MyBall.Y_Vec > Blocks[lauf].Y_Top+Blocks[lauf].height
                  && MyBall.X_Pos >= Blocks[lauf].X_Left
                  && MyBall.X_Pos <= Blocks[lauf].X_Left+Blocks[lauf].width)
            {
			   Blocks[lauf].lives--;
               
			   Player1.Score = Player1.Score + 1;
               MyBall.Y_Vec=-MyBall.Y_Vec;
			   DrawBlocks();
			   //DrawBall();
            }

         }
		 
         else if (MyBall.Y_Vec > 0)
         {
            //Collision from Top
			 if (MyBall.Y_Pos >= Blocks[lauf].Y_Top && MyBall.Y_Pos - MyBall.Y_Vec < Blocks[lauf].Y_Top
                  && MyBall.X_Pos >= Blocks[lauf].X_Left
                  && MyBall.X_Pos <= Blocks[lauf].X_Left+Blocks[lauf].width)
            {
               Blocks[lauf].lives--;
			   Player1.Score = Player1.Score + 1;
               MyBall.Y_Vec=-MyBall.Y_Vec;
			   DrawBlocks();
			   //DrawBall();
            }
         }
		 //Collision from left
		 if (MyBall.X_Vec > 0)
		 {
			 if(MyBall.X_Pos >= Blocks[lauf].X_Left && MyBall.X_Pos -MyBall.X_Vec < Blocks[lauf].X_Left
				 && MyBall.Y_Pos >= Blocks[lauf].Y_Top
				 && MyBall.Y_Pos <= Blocks[lauf].Y_Top+Blocks[lauf].height)
			 {
               Blocks[lauf].lives--; Player1.Score = Player1.Score + 1;
               MyBall.X_Vec=-MyBall.X_Vec;
			   DrawBlocks();
			   //DrawBall();
			 }
		 }
		 //Collision from right
		 else if (MyBall.X_Vec < 0)
		 {
			 if(MyBall.X_Pos <= Blocks[lauf].X_Left + Blocks[lauf].width && MyBall.X_Pos - MyBall.X_Vec > Blocks[lauf].X_Left+ Blocks[lauf].width
				 && MyBall.Y_Pos >= Blocks[lauf].Y_Top
				 && MyBall.Y_Pos <= Blocks[lauf].Y_Top+Blocks[lauf].height)
			 {
               Blocks[lauf].lives--; Player1.Score = Player1.Score + 1;
               MyBall.X_Vec=-MyBall.X_Vec;
			   DrawBlocks();
			   //DrawBall();
			 }
		 }
	     if (Blocks[lauf].lives <= 0) Blocks[lauf].exist=false;
      }//end if exist
   }//end for each block
   
}
void orbinuidMFD::CheckWon()
{
   int counts = 0;
   for(int lauf=0;lauf < BLOCKCOUNTS;lauf++)
   {
	   if (Blocks[lauf].exist) counts = counts + 1;

   }
   if (counts==0)
   {
      Player1.level = Player1.level + 1;
   }
   
      
}

//This is a simple function to put out Text on the next line after the line that was used at least by this function.
void orbinuidMFD::PrintNewLine(char* StringOut)
{
   static PrintLine = -1;
   if (StringOut==":@BEGIN:")   //This is a Keyword to tell that it has to put out Text in the first line
   {
      PrintLine = -1;
      return;
   }

   PrintLine = PrintLine + 1;
   int text_len = strlen(StringOut);   
   TextOut(MFD_HDC, 0,line(PrintLine),StringOut,text_len);    //And the text will be putted out...

   if (text_len > 38) //Warns when text is longer then 38 chars (standart lengs of the MFD-line) ??
   {
      SetTextColor(MFD_HDC,YELLOW);
	  
      PrintNewLine("@WARNING:STRING TO LONG!");
      SetTextColor(MFD_HDC,WHITE);
   }
}

//Sorry i don't know whats going on here...
int orbinuidMFD::MsgProc (UINT msg, UINT mfinald, WPARAM wparam, LPARAM lparam)
{
   switch (msg)
   {
   case OAPI_MSG_MFD_OPENED:
      orbinuid = (new orbinuidMFD (LOWORD(wparam), HIWORD(wparam), (VESSEL*)lparam));
      return (int)orbinuid;
   }
   return 0;
}

bool orbinuidMFD::ConsumeKeyBuffered (DWORD key)
{
   switch(key)
   {
   //What happend by pressing the MFD-Keys? write it down here!;
	   /*
   case OAPI_KEY_0 : DoubleUnit = DoubleUnit + 1.0; return true;
   case OAPI_KEY_1 : DoubleUnit = DoubleUnit - 1.0; return true;
   case OAPI_KEY_2 : DoubleUnit = DoubleUnit * 10;  return true;
   case OAPI_KEY_3 : DoubleUnit = DoubleUnit / 10;  return true;
      */
   case OAPI_KEY_R :    
	   if (!MyBall.free) pong(true);     
	   return true;

   case OAPI_KEY_S :   
      MyBall.X_Pos = float(Cursor.left+(Cursor.width/2));
      MyBall.Y_Pos = float(Cursor.gnd-Cursor.height);
      MyBall.X_Vec = 0;
      MyBall.Y_Vec = 0;
      Cursor.width =  int (35 VIRTUALPIXEL);
      Cursor.height = int (10 VIRTUALPIXEL);
      Cursor.gnd = int (height - 10 VIRTUALPIXEL);
	  Game.FirstZyclus = true;
      Player1.Score=0;
      Player1.Balls = BALLS;
      MyBall.free = false;
      Player1.level = 0;	   
   return true;
	   
   //case OAPI_KEY_T :    CreateBlocks(); return true;
   }
  return false;
}

//This function give us the pixel of the Line "i"...
int orbinuidMFD::line( int i )
{
   return (int)((float)i*((float)height/20.0));
}

//Here comes the caption for the help-menue of our MFD.
int orbinuidMFD::ButtonMenu (const MFDBUTTONMENU **menu) const
{
   static const MFDBUTTONMENU mnu[12] =
   {
      {"Start new Game", 0, 'S'},
      {"Release Ball", 0, 'R'},
	  /*
      {"text for button 2", 0, '2'},
      {"text for button 3", 0, '3'},
      {"text for button 4", 0, '4'},
      {"text for button 5", 0, '5'},
      {"text for button 6", 0, '6' },
      {"text for button 7", 0, '7'},
      {"text for button 8", 0, '8'},
      {"text for button 9", 0, '9'},
      {"text for button Q", 0, 'Q'},
      {"text for button W", 0, 'W'},
	  */
   };
   if (menu) *menu = mnu;
   return 12;
}

//Here comes the caption for the buttons itselfes.
char *orbinuidMFD::ButtonLabel (int bt)
{
   char *label[12] = {"NEW","REL","","","","","", "", "","", "",""};
   return (bt < 12 ? label[bt] : 0);
}

//And here we tell what happend by pressing the button by mouse. At this time (i think always),
//we can simple send back the Keycode of the Keyboardchar.
bool orbinuidMFD::ConsumeButton(int bt, int event)
{
   if (event & PANEL_MOUSE_LBDOWN)
   {
      switch( bt )
      {
      case(0)  : return ConsumeKeyBuffered (OAPI_KEY_S);
      case(1)  : return ConsumeKeyBuffered (OAPI_KEY_R);
      case(2)  : return ConsumeKeyBuffered (OAPI_KEY_2);
      case(3)  : return ConsumeKeyBuffered (OAPI_KEY_3);
      case(4)  : return ConsumeKeyBuffered (OAPI_KEY_4);
      case(5)  : return ConsumeKeyBuffered (OAPI_KEY_5);
      case(6)  : return ConsumeKeyBuffered (OAPI_KEY_6);
      case(7)  : return ConsumeKeyBuffered (OAPI_KEY_7);
      case(8)  : return ConsumeKeyBuffered (OAPI_KEY_8);
      case(9)  : return ConsumeKeyBuffered (OAPI_KEY_9);
      case(10) : return ConsumeKeyBuffered (OAPI_KEY_Q);
      case(11) : return ConsumeKeyBuffered (OAPI_KEY_W);
      default  : return false;
      }
   }
   return false;
}
//This was all.
